import { Component, Prop, Vue } from 'vue-property-decorator'
import VueClipboard from 'vue-clipboard2'
import httpClient from '@/api/Main/HttpClient'
import { ToggleNewClientTypeRequest } from '@/api/Main/Schemas/ToggleNewClientTypeSchema'
import { UserIdentificationByIdenfyRequest } from '@/api/Main/Schemas/UserIdentificationByIdenfySchema'

Vue.use(VueClipboard)

@Component
export default class UserTab extends Vue {
  @Prop()
  clientTypeUpdate!: string

  personalCode!: string
  user!: string
  clientType = 'New';
  copyText = '';

  update () {
    if (this.clientType === 'New') {
      const newToggle = new ToggleNewClientTypeRequest()
      newToggle.personalCode = this.personalCode

      httpClient.toggleNewClientType(newToggle)
    } else {
      const regularToggle = new ToggleNewClientTypeRequest()
      regularToggle.personalCode = this.personalCode

      httpClient.toggleRegularClientType(regularToggle)
    }
  }

  identificationByIdenfy () {
    const userIdentificationByIdenfy = new UserIdentificationByIdenfyRequest()
    userIdentificationByIdenfy.user = this.user

    httpClient.userIdentificationByIdenfyType(userIdentificationByIdenfy).then((data: any) => {
      this.copyText = data.data.url
    })
  }

  setClientType (event: FocusEvent) {
    // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
    // @ts-ignore
    this.clientType = event.target.value
  }

  setPersonalCode (event: FocusEvent) {
    // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
    // @ts-ignore
    this.personalCode = event.target.value
  }

  setUserId (event: FocusEvent) {
    // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
    // @ts-ignore
    this.user = event.target.value
  }
}
